﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
  using HeuristicLab.Algorithms.PushGP.Interpreter;

  public class CompareStringLengthsPushData : Data<string[], bool>, IPushData {
    public CompareStringLengthsPushData(Example<string[], bool>[] training, Example<string[], bool>[] test)
      : base(training, test, 0, test.Length) {
    }

    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
      interpreter.NameStack.Push(Training[index].Input);
    }

    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
      interpreter.NameStack.Push(Test[index].Input);
    }

    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
      return this.CompareOutput(
        interpreter.BooleanStack,
        index,
        this.Training,
        data => data == interpreter.BooleanStack.Top ? 1 : 0);
    }

    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
      return this.CompareOutput(
        interpreter.BooleanStack,
        index, this.Test,
        data => data == interpreter.BooleanStack.Top ? 1 : 0);
    }
  }
}
